using System;
using System.IO;
using System.Text;
using System.Diagnostics;

namespace TestSVNAuth
{
	public class Log{
		private static FileStream m_fs;
		private static string files = @"E:\Temp\SVN_SRC\hooks\info.txt";

		public static FileStream FS{
			get{ 
				if( m_fs == null){
					if( File.Exists(files))
					{
						File.Delete(files);
					}
					m_fs = new FileStream(files,FileMode.CreateNew,FileAccess.ReadWrite);
				}
				return m_fs;
			}
		}

		static public void WriteFile(string Info)
		{
			Info += "\r\n";
			byte[] sss = Encoding.ASCII.GetBytes(Info);
			FS.Write(sss,0,sss.Length);
			FS.Flush();
		}

		static public void WriteFile(string[] Infos){
			WriteFile(Infos.Length.ToString());
			byte[] sss;
			foreach( string i in Infos){
				sss = Encoding.ASCII.GetBytes( i + "| ");
				FS.Write(sss,0,sss.Length);
				FS.Flush();
			}
			WriteFile("");
		}
	}

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static int Main(string[] args)
		{
			try
			{

				string Author = SvnHandler.GetAuthor( args[0],args[1]);
				string[] Paths = SvnHandler.GetCommitFiles(args[0],args[1]);
				Security sec = new Security("Config.ini");
				if( sec.CommitCheck(Author,Paths[0]))
				{
					return 0;
				}
				else
				{
					return -1;
				}
			}
			catch(Exception ex){
				Log.WriteFile(ex.ToString());
				return -1;
			}

		} 

		/*
		[Output]
		hbifts
		
		[Error]
		
		[Output]
		A   CnBlogs/Helper/hBifTs/1.txt
		A   CnBlogs/Helper/hBifTs/2.txt
		A   CnBlogs/Helper/hBifTs/Copy of 1.txt
		A   CnBlogs/Helper/hBifTs/Copy of 2.txt

		[Error]

		 * 
		 */

		static public int TestFs(string[] args){
			//
			// TODO: Add code to start application here
			FileStream fs = new FileStream(@"E:\Temp\SVN_SRC\hooks\info.txt",FileMode.OpenOrCreate,FileAccess.ReadWrite);
			foreach( string i in args)
			{
				//			WriteFile(fs,i);
			}			
			//		WriteFile(fs, System.AppDomain.CurrentDomain.BaseDirectory);
			//		WriteFile(fs,System.Environment.CommandLine);
			SvnLook(fs,"author",args[0],args[1]);
			SvnLook(fs,"changed",args[0],args[1]);

			WriteFile(fs,"--------------------");
			WriteFile(fs,SvnHandler.GetAuthor(args[0],args[1]) );
			string[] files = SvnHandler.GetCommitFiles(args[0],args[1]);
			WriteFile(fs,files.Length.ToString());
			foreach( string i in files)
			{
				WriteFile(fs,i);
			}

			fs.Close();
			return 0;
		}

		static public void SvnLook(FileStream fs,string arg,string arg1,string arg2)
		{
			Process pro = new Process();
			pro.StartInfo.FileName = @"svnlook.exe";
			pro.StartInfo.CreateNoWindow = true;
			pro.StartInfo.RedirectStandardError = true;
			pro.StartInfo.RedirectStandardOutput = true;
			pro.StartInfo.UseShellExecute = false;
			pro.StartInfo.Arguments = arg + " "  + arg1 + " -t " + arg2;
			pro.Start();
			pro.WaitForExit();
			WriteFile(fs,"[Output]");
			WriteFile(fs,pro.StandardOutput.ReadToEnd());
			WriteFile(fs,"[Error]");
			WriteFile(fs,pro.StandardError.ReadToEnd());
		}

		static public void WriteFile(FileStream fs,string Info)
		{
			Info += "\r\n";
			byte[] sss = Encoding.ASCII.GetBytes(Info);
			fs.Write(sss,0,sss.Length);
			fs.Flush();
		}
	}
}
