using System;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;

namespace TestSVNAuth
{
	/// <summary>
	/// Summary description for IniOperate.
	/// </summary>
	public class IniHandler
	{
		[DllImport("kernel32")] // return 0 is fail.non zero is ok.
		private static extern int WritePrivateProfileString(string section,string key,
			string val,string filePath);

		[DllImport("kernel32")]
		private static extern int GetPrivateProfileString(string section,string key,
			string def,StringBuilder retVal,int size,string filePath);

		private string m_filepath;

		public string FilePath{
			get{ return m_filepath;}
			set{
				if( File.Exists(value))
				{
					m_filepath = value;
				}
				else 
				{
					throw new FileNotFoundException("FileNotFound",value);
				}
			}
		}

		public IniHandler()
		{				
		}

		public IniHandler(string FilePath){
			Log.WriteFile(FilePath);
			this.FilePath = FilePath;
		}

		public string Read(string Section,string Key){
			StringBuilder sb = new StringBuilder();
			int len = GetPrivateProfileString(Section,Key,null,sb,int.MaxValue,FilePath);
			if( len == 0){
				return String.Empty;
			}
			else
			{
				return sb.ToString(0,len).ToLower();
			}
		}

		public bool Write(string Section,string Key,string Value){
			return WritePrivateProfileString(Section,Key,Value,FilePath) == 0 ? false : true;
		}
		

	}
}
