using System;

namespace TestSVNAuth
{
	/// <summary>
	/// Summary description for Security.
	/// </summary>
	public class Security
	{
		private IniHandler ih;

		public Security(string ConfigFile)
		{
			ih = new IniHandler( System.AppDomain.CurrentDomain.BaseDirectory + ConfigFile);
		}

		// CnBlogs/Helper/hBifTs/2.txt

		private string GetGlobalDirectory(){
			string dir = ih.Read("Config","BaseDirectory");
			if( !dir.EndsWith("/")){
				dir = dir + "/";
			}
			Log.WriteFile(dir);
			return dir;
		}

		private string[] GetDenyUsers(){
			string users = ih.Read("Deny","Accounts");
			if( users.Length == 0)
			{
				return new string[]{""};
			}
			return users.Split(',');
		}

		private string[] GetAllowUsers(string Author)
		{
			string users = ih.Read("Allow",Author);
			if( users.Length == 0){
				return new string[]{""};
			}
			return users.Split(',');
		}

		public bool CommitCheck(string Author,string Path){
			try
			{
				string dir = GetGlobalDirectory();
				if( dir == null)
				{
					return false;
				}
				else
				{
					return CheckSecurityRules(Author,Path,dir);
				}
			}
			catch(Exception ex){
				Log.WriteFile(ex.ToString());
				return false;
			}
		}

		private bool CheckSecurityRules(string Author,string Path,string BaseDir){

			Log.WriteFile(Author);
			Log.WriteFile(Path);
			Log.WriteFile(BaseDir);

			if( !Path.StartsWith( BaseDir)){
				Log.WriteFile(Path + " not start with " + BaseDir);
				return false;
			}

			// Is this Account denied?
			string[] users = GetDenyUsers();
			Log.WriteFile(users);
			foreach( string i in users){
				if( i.Trim() == Author)
				{
					Log.WriteFile("Deny Users /" + i + "/");
					return false;
				}
			}

			if( Path.StartsWith(BaseDir + Author) )
			{				
				return true;
			}

			Log.WriteFile(Path + " not start with " + BaseDir + Author);

			// Is this Account allowed?
			string commitDir = Path.Substring( BaseDir.Length,Path.IndexOf("/",BaseDir.Length) - BaseDir.Length );
			Log.WriteFile( commitDir);
			users = GetAllowUsers( commitDir);
			Log.WriteFile(users);
			foreach( string i in users){
				if( i.Trim() == Author ){
					Log.WriteFile("Allow Users /" + i + "/");
					return true;
				}
			}
			return false;
		}
	}
}
