using System;
using System.Diagnostics;

namespace TestSVNAuth
{
	/// <summary>
	/// Summary description for SvnHandler.
	/// </summary>
	public class SvnHandler
	{
		private static string m_filename = @"svnlook.exe";

		private SvnHandler()
		{
		}

		static private string InvokeProc(string ReposPath,string Txn,string LookType){
			Process proc = new Process();
			proc.StartInfo.FileName = m_filename;
			proc.StartInfo.UseShellExecute = false;
			proc.StartInfo.RedirectStandardError = true;
			proc.StartInfo.RedirectStandardOutput = true;
			proc.StartInfo.CreateNoWindow = true;
			proc.StartInfo.Arguments = LookType + " " + ReposPath + " -t " + Txn;

			proc.Start();
			proc.WaitForExit();
			return CheckString( proc.StandardOutput.ReadToEnd() );
		}

		static public string GetAuthor(string ReposPath,string Txn){
			string info =  InvokeProc( ReposPath,Txn,"author");
			info = info.ToLower();
			Log.WriteFile(info);
			return info;
		}

		static public string[] GetCommitFiles(string ReposPath,string Txn){
			string temp = CheckString(InvokeProc(ReposPath,Txn, "changed"));
			Log.WriteFile(temp);
			string[] res = temp.Split( "\r\n".ToCharArray() );
			Log.WriteFile(res);
			string[] files = new string[res.Length/2];
			if( files.Length == 0){
				files = new string[1];
			}
			Log.WriteFile(files.Length.ToString());
			for(int i=0;i<files.Length;i++){
				files[i] = res[i*2].Remove(0,4).ToLower();
			}
			Log.WriteFile(files);
			return files;
		}

		static private string CheckString(string Source){
			Source = Source.Remove( Source.Length-2,2);
			if( Source.Length == 0)
			{
				throw new ArgumentNullException();
			}
			return Source;
		}
	}
}
